/**
Author  : Laurent Tardif
Date    : 05 01 2001
Content : Define a parser for KaomiDocument

#
# HotSpot Virtual Machine Error, EXCEPTION_ACCESS_VIOLATION
# Please report this error at
# http://java.sun.com/cgi-bin/bugreport.cgi
#
# Error ID: 4F533F57494E13120E43505002D4
#


*/

package fr.fluxmedia.transmorpher.Parser ;


// Imported XML CLasses

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;

//Imported SAX Classes

import org.xml.sax.SAXException;
import org.xml.sax.AttributeList;

//Imported JAVA CLasses

import java.io.IOException;

import java.util.Stack;
import java.util.Vector;
import java.util.StringTokenizer;
import java.lang.Integer;

//Imported TRansmorpher CLASSES

import fr.fluxmedia.transmorpher.Files.* ;
import fr.fluxmedia.transmorpher.TProcessFactory.XML_Port ;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcessFactory ;
import fr.fluxmedia.transmorpher.TProcessFactory.* ;

/**
Author  : Laurent Tardif
Date    : 05 01 2001
Content : Define a parse for process description file.
          This parser us a sub parser for ruleset.

*/
public final class ProcessParser
 extends FMParser {

  /** the TProcessFactory */
  TProcessFactory iXSLT_PF = null;

  /** stack of XLSTProcess Composite*/
  //Stack iContext = new Stack();

  /** The current TagElement modified*/
  String iModTagName = null;

  /** The reader which start the transformation process */
//  TProcessBasic_Reader iReader = null;
  
  /** The root for all tempalte */
  TProcessComposite vTemplateList = null ;
  
  /** The iXslFile */
  ReadWrite iXslFile = null;
  
  Vector iRemAttList = new Vector(5,5);

  /** The constructor, build the XML PArser but not parse the document */
  public ProcessParser(TProcessFactory pXSLT_PF) {
    super();
    iXSLT_PF = pXSLT_PF;
    try {
      //System.out.println("[ProcessParser] : creation of the parser : " );
      vTemplateList = new TProcessComposite(new String[0], new String[0]);
      vTemplateList.setName("Template");
    } catch (Exception E) {
      System.out.println("[ProcessParser] : Error durring the creation of the parser : " +E);
    } //fin try
  }

  /* ************* */
  /* START ELEMENT */
  /* ************* */

  /** Call by the XML parser at the begining of an element */
  public final void startElement(String pName, AttributeList attrs) {
    try {
      if (pName.equals("transmorpher")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessList(attrs);
      } else if (pName.equals("process")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startComplexProcess(attrs);
      }else if (pName.equals("main")) {
        //On appel le run a la fin du main
        //System.out.println("startElement ProcessParser : " + pName);
        startComplexProcess(attrs);
      } else if (pName.equals("generate")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessReader(attrs);
      } else if (pName.equals("loop")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessLoop(attrs);
      } else if (pName.equals("dispatch")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessDispatcher(attrs);
      } else if (pName.equals("apply-external")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessXslt(attrs);
      } else if (pName.equals("connector")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessConnector(attrs);
      } else if (pName.equals("serialize")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessSerializer(attrs);
      } else if (pName.equals("apply-process")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessRefComplex(attrs);
      } else if (pName.equals("query")) {
        //System.out.println("startElement ProcessParser : " + pName);
        startProcessQuery(attrs);
      } else if (pName.equals("defineRuleSet")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        iXslFile=RuleSetParser.startDefineRuleSet(attrs);
      } else if (pName.equals("ruleset")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        startRuleSet(attrs);
      } else if (pName.equals("maptag")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        RuleSetParser.startMapTag(iXslFile,attrs);
      } else if (pName.equals("remtag")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        RuleSetParser.startRemTag(iXslFile,attrs);
      } else if (pName.equals("flatten")) {
        //System.out.println("startElement ProcessParser : " + pName);
        RuleSetParser.startFlatten(iXslFile,attrs);
      } else if (pName.equals("modtag")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        iModTagName=RuleSetParser.startModTag(iXslFile,attrs);
      } else if (pName.equals("mapatt")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        RuleSetParser.startMapAtt(iRemAttList,iModTagName,iXslFile, attrs);
      } else if (pName.equals("rematt")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        RuleSetParser.startRemAtt(iRemAttList,iModTagName,attrs);
      } else if (pName.equals("addatt")) {
        //System.out.println("startElement ProcessParser :  " + pName);
        RuleSetParser.startAddAtt(iXslFile,attrs);
      } else {
        System.out.println("startElement ProcessParser : ELEMENT INCONU" + pName);
      } //end if
    } catch (TransformerException TE) {
      System.out.println("[ProcessParser]TransformerException" +TE);
    } catch (SAXException SE) {
      System.out.println("[ProcessParser]Erreur SAX(" + SE+")");
      System.out.println("[ProcessParser]Erreur SAX(" + SE.getMessage()+")");
      System.out.println("[ProcessParser]Erreur SAX(" + SE.getException()+")");
    } catch (IOException IO) {
      System.out.println("IOException" +IO);
    } //end try


  } // startElement(String,AttributeList)



  /* *********** */
  /* END ELEMENT */
  /* *********** */

  /** Call by the XML parser at the end of an element */
  public final void endElement(String pName) {
    try {
      if (pName.equals("transmorpher")) {
        endProcessList();
      } else if (pName.equals("process")) {
        endComplexProcess();
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("main")) {
        endComplexProcess();
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("generate")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("dispatch")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("apply-external")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("connector")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("loop")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("serialize")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("apply-process")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("query")) {
        //System.out.println("endElement ProcessParser : " + pName);
      } else if (pName.equals("defineRuleSet")) {
        //System.out.println("endElement  defineruleset");
        RuleSetParser.endDefineRuleSet(iXslFile);
      }else if (pName.equals("modtag")) {
        //System.out.println("endElement modtag");
        RuleSetParser.endModTag(iRemAttList,iXslFile);
      } else if (pName.equals("maptag")) {
        //System.out.println("endElement Not imimplemented" +pName);
      } else if (pName.equals("remtag")) {
        //System.out.println("endElement Not imimplemented" +pName);
      } else if (pName.equals("flatten")) {
        System.out.println("endElement Not imimplemented" +pName);
      } else if (pName.equals("mapatt")) {
        //System.out.println("endElement Not imimplemented" +pName);
      } else if (pName.equals("rematt")) {
        //System.out.println("endElement Not imimplemented" +pName);
      } else if (pName.equals("addatt")) {
        //System.out.println("endElement Not imimplemented" +pName);
      } else {
        System.out.println("endElement ProcessParser : ELEMENT INCONU" + pName);
      } //end if
    } catch (SAXException SE) {
      System.out.println("SAXException" +SE);
    } catch (IOException IO) {
      System.out.println("IOException" +IO);
    } //end try
  } //end endeLement


  /** start the parsing of a process list */
  protected final void startProcessList(AttributeList attrs)
    throws TransformerException,
           TransformerConfigurationException,
           SAXException,
           IOException {

    TProcess vCurrent = TProcessFactory.newComposite(new String[0],new String[0]);
    vCurrent.setName("Header");
    iContext.push(vCurrent);
  } //end proc


  /** start the parsing of a ComplexProcess*/
  protected final  void startComplexProcess(AttributeList attrs)
    throws TransformerException,
           TransformerConfigurationException,
           SAXException,
           IOException {
    String pName = "Composite ";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
//    System.out.println("[ProcessParser]Creation d'un complexe : 0.0");
    TProcess vCurrent = TProcessFactory.newComposite(iPA.getIn(),iPA.getOut());
    CreateComposite((TProcessComposite)vCurrent,iPA);
    iContext.push(iPA);
    iContext.push(vCurrent);
  } //end proc


  /**
  Nbin  : 0
  NbOut : 0
  start the parsing of a ProcessReader
  */
    protected  final void startProcessReader(AttributeList attrs)
    throws SAXException,
           IOException {
    String pName ="Reader";
    //System.out.println("analyse arg  d'un reader :");
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un reader :");
    TProcess vCurrent =  iXSLT_PF.newGenerator("xml-reader",iPA.getOut(),iPA.getFilename());
    Create(vCurrent,iPA);
  } //end proc

  /**
  Nbin  : X
  NbOut : Y
  start the parsing of a ProcessReader
  */
  protected  final void startProcessLoop(AttributeList attrs)
  throws TransformerException,
         TransformerConfigurationException,
         SAXException,
         IOException {
          
    String pName ="Loop";
    //System.out.println("analyse arg  d'un loop :");
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un loop :");
    TProcess vCurrent =  iXSLT_PF.newLoop(iPA.getIn(),iPA.getOut(),iPA.getRefOn(),iPA.getCount(),vTemplateList);
    Create(vCurrent,iPA);
  } //end proc


  /**
  NbIn = 0
  NbOut = depend on document
  start the parsing of a ProcessDispatcher
  */

  protected  final void startProcessDispatcher(AttributeList attrs) {
    String pName ="Dispatcher";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un Dispatcher :");
    TProcess vCurrent = TProcessFactory.newDispatcher("basic",iPA.getIn(),iPA.getOut());
    Create(vCurrent,iPA);
  } //end proc

  /** start the parsing of a ProcessXslt*/
  protected  final void startProcessXslt(AttributeList attrs)
     throws TransformerException,
     TransformerConfigurationException,
     SAXException,
     IOException {

    String pName ="Xslt";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un Xslt :");
    TProcess vCurrent = TProcessFactory.newTransformer("XSLT",iPA.getIn(),iPA.getOut(),iPA.getFilename());
    Create(vCurrent,iPA);

  } //end proc

  /**
  start the parsing of a ProcessReader  */
    protected  final void startProcessQuery(AttributeList attrs) throws TransformerException,
     TransformerConfigurationException,
     SAXException,
     IOException  {
    String pName ="Query";
    //System.out.println("analyse arg  d'un reader :");
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un reader :");
    TProcess vCurrent = TProcessFactory.newQuery("internal",iPA.getIn(),iPA.getOut(),iPA.getFilename());
    Create(vCurrent,iPA);
  } //end proc

  /** start the parsing of a RuleSet (use of)*/
  protected  final void startRuleSet(AttributeList attrs)
     throws TransformerException,
     TransformerConfigurationException,
     SAXException,
     IOException {

    String pName ="RuleSet";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    TProcess vCurrent = TProcessFactory.newRuleSet(iPA.getIn(),iPA.getOut(),iPA.getRefOn());
    Create(vCurrent,iPA);

  } //end proc

  /** start the parsing of a ProcessConnector*/
  protected  final void startProcessConnector(AttributeList attrs) {
    String pName ="Connector";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un Connector :");
    TProcess vCurrent = TProcessFactory.newConnector("basic",iPA.getIn(),iPA.getOut());
    Create(vCurrent,iPA);
  } //end proc

   /** start the parsing of a ProcessSerializer*/
   protected  final void startProcessSerializer(AttributeList attrs)
    throws SAXException,
    IOException  {

    String pName ="Connector";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("Creation d'un Connector :");
    TProcess vCurrent = TProcessFactory.newSerializer("basic",iPA.getIn(),iPA.getFilename());
    Create(vCurrent,iPA);
  } //end proc

   /** start the parsing of a ProcessSerializer*/
   protected  final void startProcessRefComplex(AttributeList attrs)
    throws SAXException,
    IOException  {

    String pName ="Ref Complexe";
    ParserAnswer iPA= AnalyseArg(attrs);
    if (iPA.getName()==null) iPA.setName(pName);
    //System.out.println("[ProcessParser]Creation d'un ref complex:");
    CreateRefComplex(iPA);
  } //end proc


  /** start the parsing of a ComplexProcess*/
  protected  final void endComplexProcess()
   throws SAXException, IOException {

    //System.out.println("begin end complex process");

    TProcessComposite vCurrent = (TProcessComposite) iContext.pop();
    ParserAnswer iPA= (ParserAnswer) iContext.pop();
    vCurrent.CreateLink();
    vCurrent.LinkCompositePort();

    //new fr.fluxmedia.transmorpher.Interface.DisplayingProcess(vFather);
    //System.out.println("fin Coucou" + vFather );
  }

  /** start the parsing of a ProcessList*/
  protected  final void endProcessList() throws SAXException, IOException {
    TProcessComposite vFather = (TProcessComposite) iContext.pop();
/*
    if (iReader !=null) {
      //System.out.println("Start process");
      iReader.execProcess();
    }
*/
  }

  /** Analyze the port Name */
  public static final String[] AnalysePortName(String pListe) {
    StringTokenizer vTokens = new StringTokenizer( pListe, " ", true );
    String[] vAns = new String[vTokens.countTokens()/2+1];
    String vToken = null;
    int i = 0;
    while ( vTokens.hasMoreTokens() ) {
       vToken = vTokens.nextToken();
       if (vToken.equals(" ")) {
       } else {
          vAns[i++]=vToken;
       } //end if
    }//end while
    return vAns;
  } //end proc

  /** analyse the argument of processElement */
  protected final ParserAnswer AnalyseArg(AttributeList attrs) {
    ParserAnswer vAns= new ParserAnswer();
    //System.out.println(" AnalyseArg");
    String vAttName = null;
    if (attrs != null) {
      int len = attrs.getLength();
      for (int i = 0; i < len; i++) {
        vAttName= attrs.getName(i); //.toLowerCase();
        //System.out.println(" AnalyseArg : in"+ vAttName);
        if (vAttName.equals("name")){
          vAns.setName(attrs.getValue(i));
        } else if (vAttName.equals("out")){
          //System.out.println(" AnalyseArg : out");
           vAns.setOut(AnalysePortName(attrs.getValue(i)));
        } else if (vAttName.equals("in")){
          //System.out.println(" AnalyseArg : in");
           vAns.setIn(AnalysePortName(attrs.getValue(i)));
        } else if (vAttName.equals("file")){
           vAns.setFilename(attrs.getValue(i));
        } else if (vAttName.equals("type")){
           vAns.setType(attrs.getValue(i));
        } else if (vAttName.equals("refOn")){
           vAns.setRefOn(attrs.getValue(i));
        } else if (vAttName.equals("count")){
           vAns.setCount(Integer.parseInt(attrs.getValue(i)));
        } else {
          System.out.println("Unkown attribut : Name="+vAttName+" value="+attrs.getValue(i));
        }
      } //end for
    } //end if
    //System.out.println("fin AnalyseArg");
    return vAns;
  } //end proc

    /** Assign the attribute on the current element */
  protected final void Create(TProcess vCurrent, ParserAnswer iPA) {
    //System.out.println("Create " +iPA.getName());
    vCurrent.setName(iPA.getName());
    TProcessComposite vFather = (TProcessComposite) iContext.peek();
    if (vFather!=null) {
      vFather.addProcess(vCurrent);
    } else {
      System.out.println("[ProcessParser] Error , the Father is null");
    }
    String[] iOut=iPA.getOut();
    String[] iIn=iPA.getIn();
    int iNbIn = iIn.length;
    int iNbOut = iOut.length;
    vCurrent.setName(iPA.getName());

    //System.out.println("Create " +iPA.getName()+" Nbin= "+iNbIn+" NbOut= "+iNbOut);
    for (int i=0;i<iNbOut; i++) {
      //System.out.println("[create out : " +iPA.getName()+"] "+iOut[i]);
      if ( vCurrent.getOut(i)!=null) {
		  vFather.InsertUnlinkedOutPort(iOut[i],vCurrent.getOut(i));
      	  vCurrent.getOut(i).setCompositeName(iOut[i]);
	  } //for loop
    }

    for (int i=0;i<iNbIn; i++) {
      //System.out.println("[create in : " +iPA.getName()+"] "+iIn[i]);
      vFather.InsertUnlinkedInPort(iIn[i],vCurrent.getIn(i));
      vCurrent.getIn(i).setCompositeName(iIn[i]);
    }

  }

    /** Assign the attribute on the current element */
  protected final void CreateComposite(TProcessComposite vCurrent, ParserAnswer iPA) {
    //System.out.println("Create " +iPA.getName());
    vCurrent.setName(iPA.getName());
    vTemplateList.addProcess(vCurrent);
        
    String[] iOut=iPA.getOut();
    String[] iIn=iPA.getIn();
    int iNbIn = iIn.length;
    int iNbOut = iOut.length;
    vCurrent.setName(iPA.getName());

    //System.out.println("Create " +iPA.getName()+" Nbin= "+iNbIn+" NbOut= "+iNbOut);
    for (int i=0;i<iNbOut; i++) {
      //System.out.println("[ProcessParser:CrComposite][create out : " +iPA.getName()+"] "+iOut[i]);
      vCurrent.InsertCompositeOutPort(iOut[i]);
    }
    
    for (int i=0;i<iNbIn; i++) {
      //System.out.println("[ProcessParser:CrComposite][create in : " +iPA.getName()+"] "+iIn[i]);
      vCurrent.InsertCompositeInPort(iIn[i]);
    }
    
  }
    /** Assign the attribute on the current element */
  protected final void CreateRefComplex(ParserAnswer iPA) {
    //System.out.println("[ProcessParser]Create RefComplexe" +iPA.getName());

    TProcessComposite vFather = (TProcessComposite) iContext.pop();
    ParserAnswer vFatherPA = (ParserAnswer) iContext.pop();
    TProcessComposite vRoot = (TProcessComposite) iContext.peek();
    iContext.push(vFatherPA);
    iContext.push(vFather);
    TProcess vCurrent = null;
   
    vCurrent = vTemplateList.getProcess(iPA.getRefOn());
/*
    if (vCurrent==null) {
      System.out.println("le process pas trouve : "+ iPA.getRefOn());
    } else {
      System.out.println("le process trouve : " +  vTemplateList.getProcess(iPA.getRefOn()).getName());
      
    }
*/
    vCurrent = vCurrent.Copy(vFather);
    vCurrent.setName(iPA.getName()); //+System.currentTimeMillis());

    if (vFather!=null) {
      String[] iOut=iPA.getOut();
      String[] iIn=iPA.getIn();
      int iNbIn = iIn.length;
      int iNbOut = iOut.length;
      
      for (int i=0;i<iNbOut; i++) {
        //System.out.println("[processParser : insert out : " +iPA.getName()+"] "+iOut[i]);
        if (vCurrent.getOut(i)!=null) {
			vFather.removeUnlinkedOutPort(vCurrent.getOut(i).getName());
        	vCurrent.getOut(i).setCompositeName(iOut[i]);
        	vFather.InsertUnlinkedOutPort(iOut[i],vCurrent.getOut(i));
		} //else it's for loop, we don't know out port staticaly
      }
      for (int i=0;i<iNbIn; i++) {
        //System.out.println("[processParser : insert in : " +iPA.getName()+"] "+iIn[i]);
        vFather.removeUnlinkedInPort(vCurrent.getIn(i).getName());
        vCurrent.getIn(i).setCompositeName(iIn[i]);
        vFather.InsertUnlinkedInPort(iIn[i],vCurrent.getIn(i));
      }
    } else {
      System.out.println("[ProcessParser] the Father of the apply-process is null");
    }
  }

}//end class
