/**
Author  : Laurent Tardif
Date    : 05 01 2001
Content : Define a parser for KaomiDocument

#
# HotSpot Virtual Machine Error, EXCEPTION_ACCESS_VIOLATION
# Please report this error at
# http://java.sun.com/cgi-bin/bugreport.cgi
#
# Error ID: 4F533F57494E13120E43505002D4
#


*/
package fr.fluxmedia.transmorpher.Parser ;


// imported SAX Classes 

import org.xml.sax.AttributeList;

//Imported JAVA CLasses

import java.util.Vector;


//Imported Transmorpher CLasses 

import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;


/**
Author  : Laurent Tardif
Date    : 05 01 2001
Content : Define the rule set parser 
*/

public final class RuleSetParser {


/**
  *
  *
  * Construction of stylesheet
  *
  *
  **/

  /** Allow to define rule set, this definition build a XSL file */
  protected static final ReadWrite startDefineRuleSet(AttributeList attrs) {
    
    //System.out.println("START FILE");
    ReadWrite FileRW = new ReadWrite(attrs.getValue("name")+".xsl",Constants.WRITE); 
    FileRW.Writeln("<?xml version=\"1.0\"?>"); 
    FileRW.Writeln("<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\">");
    FileRW.Writeln("");    
    FileRW.Writeln("<!-- ************************************************************ -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- This style sheet was generated by the FluxMdia Transmorpher -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- ************************************************************ -->");    
    FileRW.Writeln("");    

    FileRW.Writeln("<!-- ************************************************************ -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- COMMON PART : copy all attribute, all element, all text part -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- ************************************************************ -->");   
    FileRW.Writeln("");    
    
    FileRW.Writeln("  <!-- copy la racine et ses attributs -->");
    FileRW.Writeln("  <xsl:template match=\"/\">");
//    FileRW.Writeln("    <xsl:apply-templates select=\"*\"/>");
    FileRW.Writeln("    <xsl:apply-templates/>");
    FileRW.Writeln("  </xsl:template>");
    FileRW.Writeln("  <xsl:template match=\"@*\">");
    FileRW.Writeln("      <xsl:attribute name=\"{name()}\"> <xsl:value-of select=\".\"/>");
    FileRW.Writeln("      </xsl:attribute>");
    FileRW.Writeln("  </xsl:template>");
    FileRW.Writeln("");    
    FileRW.Writeln(" <!-- copy les element ou et leur attributs -->");
    FileRW.Writeln("   <xsl:template match=\"*\">");
    FileRW.Writeln("    <xsl:copy>");
    FileRW.Writeln("      <xsl:apply-templates select=\"*|@*|text()\"/>");
//    FileRW.Writeln("      <xsl:apply-templates select=\"@*\"/>");
//    FileRW.Writeln("      <xsl:apply-templates select=\"*\"/>");
//    FileRW.Writeln("      <xsl:value-of select=\"text()\"/>");
    FileRW.Writeln("    </xsl:copy>");
    FileRW.Writeln("  </xsl:template>");
    FileRW.Writeln("");    

    return FileRW ;
  }

  /** Allow to define a basic transformation : Map an attribute into another one
    <maptag match="<x>" target="<y>" />
 */
  protected static final void startMapTag(ReadWrite iXslFile,AttributeList attrs){
    iXslFile.Writeln(2,"<!-- Creation d'un MapTAG -->");  
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match")+"\">");
    iXslFile.Writeln(4,"<"+attrs.getValue("target")+">");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"@*\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\"/>");
    iXslFile.Writeln(6,"<xsl:value-of select=\"text()\"/>");                      
    iXslFile.Writeln(4,"</"+attrs.getValue("target")+">");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");
  }

  /** Allow to define a basic transformation : remove an element */
  protected static final void startRemTag(ReadWrite iXslFile,AttributeList attrs){
    iXslFile.Writeln(2,"<!-- Creation d'un RemTAG -->");  
    iXslFile.Writeln(4,"<xsl:template match=\""+attrs.getValue("content")+"/"+attrs.getValue("match")+"\"/>");
    iXslFile.Writeln(2,"<!--   fin d'un RemTAG    -->");  
  }

  /** Allow to define a basic transformation Flatten an element*/
  protected static final void startFlatten(ReadWrite iXslFile,AttributeList attrs){
    iXslFile.Writeln(2,"<!-- Creation d'un FlattenTAG -->");  
    iXslFile.Writeln(2,"<xsl:template match=\"*\" mode=\"TraiteA\"/>");
    iXslFile.Writeln("");    
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match") +"\" mode=\"TraiteNonA\"/>");
    iXslFile.Writeln("");
    
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match") +"\" >");
    iXslFile.Writeln(4,"<xsl:copy>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"@*\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\" mode=\"TraiteNonA\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\" mode=\"TraiteA\"/>");
    iXslFile.Writeln(6,"<xsl:value-of select=\"text()\"/>");
    iXslFile.Writeln(4,"</xsl:copy>");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");

    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match") +"\" mode=\"TraiteA\">");
    iXslFile.Writeln(4,"<xsl:copy>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"@*\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\" mode=\"TraiteNonA\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\" mode=\"TraiteA\"/>");
    iXslFile.Writeln(6,"<xsl:value-of select=\"text()\"/>");
    iXslFile.Writeln(4,"</xsl:copy>");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");
      
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match") +"/"+attrs.getValue("match") +"\" mode=\"TraiteA\">");
    iXslFile.Writeln(4,"<xsl:apply-templates select= \"*\"/>");
    iXslFile.Writeln(4,"<xsl:value-of select=\"text()\"/>");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");  
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match") +"/"+attrs.getValue("match") +"\" mode=\"TraiteNonA\"/>");
    iXslFile.Writeln("");
    iXslFile.Writeln(2,"<!-- Fin d'un FlattenTAG -->");          
    iXslFile.Writeln("");
    /*
    iXslFile.Writeln(2,"<xsl:template match=\""+attrs.getValue("match")+"\">");
    iXslFile.Writeln(4,"<"+attrs.getValue("target")+">");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"@*\"/>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\"/>");
    iXslFile.Writeln(6,"<xsl:value-of select=\"text()\"/>");                      
    iXslFile.Writeln(4,"</"+attrs.getValue("target")+">");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");
    */
  }

  /**  Allow to define a basic transformation : Modify a tag */
  protected static final String startModTag(ReadWrite iXslFile,AttributeList attrs) {

    iXslFile.Writeln("<!-- ************************************************************ -->");    
    iXslFile.Writeln("<!--                                                              -->");    
    iXslFile.Writeln("<!--                    Creation d'un ModTAG                      -->");    
    iXslFile.Writeln("<!--                                                              -->");    
    iXslFile.Writeln("<!-- ************************************************************ -->");   
    iXslFile.Writeln(""); 
    
    //iXslFile.Writeln(4,"<xsl:apply-templates match=\""+ attrs.getValue("match")+"\">"); 
    String iModTagName=attrs.getValue("name");
    
    iXslFile.Writeln(2,"<xsl:template match=\""+iModTagName+"\">");
    iXslFile.Writeln(4,"<xsl:copy>");
    iXslFile.Writeln("");
    return iModTagName;
  }
  

  /** Allow to define a basic transformation change the name of an attribute on an element */
  protected static final void startMapAtt(Vector iRemAttList, String iModTagName,ReadWrite iXslFile,AttributeList attrs){
    iXslFile.Writeln(6,"<!-- Creation d'un MapAtt -->");  
    iXslFile.Write(6,"<xsl:attribute name=\""+ attrs.getValue("target")+"\">");
    iXslFile.Write("<xsl:value-of select=\"@"+attrs.getValue("name")+"\"/>"); 
    iXslFile.Writeln("</xsl:attribute>"); 
    iXslFile.Writeln(6,"<!-- CreationFin (MapAtt) -->");
    
    iRemAttList.add(new RemAtt(iModTagName,"@"+attrs.getValue("name") ) );
  }



  /** Allow to define a basic transformation remove a tag on element */
  protected static final void startRemAtt(Vector iRemAttList, String iModTagName,AttributeList attrs){
    iRemAttList.add(new RemAtt(iModTagName,"@"+attrs.getValue("name") ) );
  }


  /** Apply the transformation for all RemAtt, which aredelayed */
  protected static final void RemAllAtt(Vector iRemAttList,ReadWrite iXslFile){
    int Size = iRemAttList.size() ;
    for (int i=0; i< Size; i++) {
      ComputeRemAtt(iXslFile,(RemAtt)iRemAttList.remove(0));  
    }
  }
  
  /** Apply the transformation for One RemAtt, which aredelayed */
  protected static final void ComputeRemAtt(ReadWrite iXslFile,RemAtt pRemAtt){
    iXslFile.Write(2,"<!-- Creation d'un RemAtt :");      
    iXslFile.Writeln(" On ne reconnait pas les attributs "+ pRemAtt.getAttributeName() 
                     +" sur les elements "+pRemAtt.getElementName()+" -->");
    iXslFile.Writeln(4,"  <xsl:template match=\""+pRemAtt.getElementName()+"/"+pRemAtt.getAttributeName()+"\"/>");
    iXslFile.Writeln(2,"<!-- Fin d'un RemAtt -->");
  }

  /** Allow to define a basic transformation : add a tag on element */
  protected static final void startAddAtt(ReadWrite iXslFile,AttributeList attrs){
    iXslFile.Writeln(6,"<!-- Creation d'un AddAtt -->");      
    iXslFile.Write(6,"<xsl:attribute name=\""+ attrs.getValue("name")+"\">");
    iXslFile.Write(attrs.getValue("value"));
    iXslFile.Writeln("</xsl:attribute>"); 
    iXslFile.Writeln("");
  }


  /** close the iXlFile */
  protected static final void endDefineRuleSet(ReadWrite iXslFile) {
    iXslFile.Writeln("</xsl:stylesheet>") ;
    iXslFile.Close();    
  }

  /** close the iXslFile */
  protected static final void endModTag(Vector iRemAttList,ReadWrite iXslFile) {
    //iXslFile.Writeln(4,"</xsl:apply-templates>");
    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*|@*|text()\"/>");    
//    iXslFile.Writeln(6,"<xsl:apply-templates select=\"@*\"/>");
//    iXslFile.Writeln(6,"<xsl:apply-templates select=\"*\"/>");
//    iXslFile.Writeln(6,"<xsl:value-of select=\"text()\"/>");
    iXslFile.Writeln(4,"</xsl:copy>");
    iXslFile.Writeln(2,"</xsl:template>");
    iXslFile.Writeln("");
    //Compute all delayed RemAttribute
    RemAllAtt(iRemAttList,iXslFile);
    iXslFile.Writeln(2,"<!-- Fin d'un ModTAG -->");  
    iXslFile.Writeln("");
  }

}//end class
