/**
  XSLT TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;


// Imported SAX CLasses 

import org.xml.sax.ContentHandler;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.AttributesImpl ;

import org.xml.sax.Locator ;


/**
  *
  * This clas provide a way to store content handler 
  * command in a stack
  *
  * @authors  laurent.Tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  
  ** WARNING MUST COPY THE CHAR * durring the stack, beacause some parser overide the variable
  */

public final class ContentHandlerInfo 
  implements ContentHandler_Commands {

  /** String array to store String parameter */
  String iStringParameters[] = new String[4];
  
  /** int array to store int parameter */
  int iIntParameters[] = new int[2];
  
  /** Attributes to store attributes parameter */
  Attributes iAttributesParameter = null;

  /** Locator to store locator parameter */
  Locator iLocatorParameter = null;
  
  /** The CharArray to store char array paramer */
  char[] iCharParameter = null;

  /** The content handler command */
  int iCommand = START_DOCUMENT;

  /** One constructor */ 
  ContentHandlerInfo(int pCommand) {
    iCommand = pCommand;
  }

  /** One constructor */
  ContentHandlerInfo(int pCommand,Locator p1) {
    iLocatorParameter = p1;
    iCommand = pCommand;
  }

  /** One constructor */
  ContentHandlerInfo(int pCommand,String p1) {
    iStringParameters[0] = p1;
    iCommand = pCommand;
  }

  /** One constructor */
  ContentHandlerInfo(int pCommand, char[] p1, int p2, int p3) {
    iCommand = pCommand;
    iCharParameter = p1;
    iIntParameters[0] = p2;
    iIntParameters[1] = p3;
  }
  
  /** One constructor */  
  ContentHandlerInfo(int pCommand,String p1, String p2) {
    this(pCommand,p1);    
    iStringParameters[1] = p2;
  }
  
  /** One constructor */
  ContentHandlerInfo(int pCommand,String p1, String p2, String p3) {
    this(pCommand,p1,p2);
    iStringParameters[2] = p3;        
  }

  /** One constructor */
  ContentHandlerInfo(int pCommand,String p1, String p2, String p3, Attributes pAtt) {
    this(pCommand,p1,p2,p3);
    iAttributesParameter = new AttributesImpl(pAtt);
    //iAttributesParameter = pAtt;    
  }  
  
  /** Get the string parameted */
  public final String getStringParameter(int i) {
    return iStringParameters[i];
  }
  
  /** get the Inr parameter */
  public final int getIntParameter(int i) {
    return iIntParameters[i];
  }
  
  /** get the locator */
  public final Locator getLocatorParameter() {
    return iLocatorParameter;
  }
  
  /** get the attributes */
  public final Attributes getAttributes() {
    return iAttributesParameter ;
  }
  
  /** get the command */
  public final int getCommand() {
    return iCommand;
  }

  /** get the car array parameter */
  public final char[] getCharParameter() {
    return iCharParameter;
  }
  
  /** get the command from the string name */
  public static final int getIntFromStringCommand(String pName) {
    String vName = pName.toLowerCase();
    if (vName.equals("start_element")) {
      return START_ELEMENT;
    } else if (vName.equals("end_element")) {
      return END_ELEMENT;
    } else if (vName.equals("start_document")) {
      return START_DOCUMENT;
    } else if (vName.equals("end_document")) {
      return END_DOCUMENT;
    } else if (vName.equals("set_document_locator")) {
      return SET_DOCUMENT_LOCATOR;
    } else if (vName.equals("skipped_entity")) {
      return SKIPPED_ENTITY;
    } else if (vName.equals("ignorable_whitespace")) {
      return IGNORABLE_WHITESPACE;
    } else if (vName.equals("processing_instruction")) {
      return PROCESSING_INSTRUCTION;
    } else if (vName.equals("characters")) {
      return CHARACTERS;
    } else if (vName.equals("start_prefix_mapping")) {
      return START_PREFIX_MAPPING;
    } else {
        //if (vName.equals("end_prefix_mapping")) {
      return END_PREFIX_MAPPING;
    }  //end if
                                      
  } //end proc
  
  
  /** convert the command to string */
  public final String toString() {
    return ContentHandlerInfo2String[iCommand];
  } //end toString

    
  
} //end class
