/**
 *
 * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
 * @since jdk 1.2 / SAX 2.0
 */
package fr.fluxmedia.transmorpher.TProcessFactory ;

import java.util.Stack ;

/**
 This class allow to define a stack which contains  ContentHandlerInfo.
 The contentHandlerInfo are used to store the ContentHandler flow 
 for the Connector element
 
  @see fr.fluxmedia.transmorpher.TProcessFactory.XSLTConnector
  @see fr.fluxmedia.transmorpher.TProcessFactory.ContentHandlerInfo ;
*/
public final class ContentHandlerInfoStack {
  
  /** The stack */
  Stack iStack = null;
  
  /** Init the stack */
  public ContentHandlerInfoStack () {
    iStack = new Stack();
  } //end constructor
  
  /** Add an element in the stack */
  public final  void add(ContentHandlerInfo p) {
    iStack.add(0,p);
  } //end Add

  /** get an element in the stack */
  public final ContentHandlerInfo get(int p) {
    return (ContentHandlerInfo)iStack.get(p);
  } //end Add
  
  /** Look at the first element in the stack */
  public final ContentHandlerInfo peek() {
    return (ContentHandlerInfo) iStack.peek();
  } //end peek
  
  /** Remove the first element in the stack */
  public final ContentHandlerInfo pop() {
    return (ContentHandlerInfo) iStack.pop();
  } //end pop
  
  /** return the size of the stack */
  public final int size() {
    return iStack.size();
  } //end size

  /** Allow to print the stack */
  public final String toString() {
    String vAns = "ContentHandlerInfoStack";
    for (int i=0; i< size(); i++) {
      vAns+="\n Element["+i+"]="+iStack.elementAt(i) ;
    }
    return vAns+"\n Fin ContentHandlerInfoStack \n";
  } //end proc toString

} //end class
