package fr.fluxmedia.transmorpher.TProcessFactory ;


// Imported SAX CLASSES

import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator ;

/**
  * This class manage a set of OneMixer Object
  *
  *
  * @author laurent.tardif@inrialpes.fr
  * @date 10 02 2001 
  * @see SAX 2.0 && JDK 1.3
*/
public final class MultipleMixer 
  extends TProcess_Impl
  implements OneMixerHandler {

  /** The list of OneMixer element */
  OneMixer[] iMixerList = null ;
  
  /** The number of the current mixer */
  int iCurrentMixer = 0 ;
  
  /** The number of mixer */
  int iNbMixer = 0;
  
  /** the content handler */
  ContentHandler iContentHandler = null;
  
  /** The constructor */
  public MultipleMixer (int pNbMixer) {
    iMixerList =new OneMixer[pNbMixer];
    iNbMixer = pNbMixer ;
    for (int i=0; i< pNbMixer; i++) {
      iMixerList[i]= new OneMixer(this);
    }
    iMixerList[iCurrentMixer].setCurrent(true); 
  }
  
  /** return a mixer */
  public final OneMixer getMixer(int p) {
    return iMixerList[p];
  }
  
  /** Set the content handler for this element */
  public final void setContentHandler(ContentHandler pContentHandler ) {
    iContentHandler = pContentHandler ;
    for (int i=0; i< iNbMixer; i++) {
      iMixerList[i].setContentHandler(pContentHandler);
    }
  }
  
  /** get the content handler for this element */
  public final ContentHandler getContentHandler( ) {
    return iContentHandler;
  } 
  
  /** when a OneMixer is finished, we execute the stack of the next mixer, and then , set 
      the next mixer active */
  public final void IsFinished() throws SAXException {
    //System.out.println("Le mixer ="+iCurrentMixer+" est fini");
      iMixerList[iCurrentMixer++].setCurrent(false); 
    if (iCurrentMixer < iNbMixer) {
      //System.out.println("on va passer au :" + (iCurrentMixer));
      iMixerList[iCurrentMixer].ComputeStack(); 
      iMixerList[iCurrentMixer].setCurrent(true); 
    } else {
      //System.out.println("Plus de mixer");      
    } //end if 
  } //end IsFinished
  
  public final void IsFinishedDuringStop() {
    System.out.println("[MultipleMixer] IsFinishedDuringStop NOT IMPLEMENTED ");
  }
  
  public final TProcess internalCopy() {
    System.out.println("[MultipleMixer] internal Copy NOT IMPLEMENTED ");
    return null;
  }
  
  
} //end class
