/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

//Imported SAX Classes 

import org.xml.sax.ContentHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator ;
import org.xml.sax.SAXException;

public class OneInMultipleOut 
  implements ContentHandler {

  ContentHandler [] iListOfContent = null ;

  int iNbContentHandler = 0;

  public OneInMultipleOut (int p) {
    iListOfContent = new ContentHandler[p];
  }

  public void addContentHandler(ContentHandler pContentHandler) {
     iListOfContent[ iNbContentHandler++] = pContentHandler ;
  }
  
  
  public void startElement(String ns,String localName,String name, Attributes atts) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startElement( ns, localName, name,  atts);
    }
  }

  public void endElement(String ns,String localName,String name) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endElement( ns, localName, name);
    }
  }

  public void setDocumentLocator(Locator locator) {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].setDocumentLocator( locator);
    }
  }

  public void startDocument() throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startDocument();
    }
  }
  public void endDocument() throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endDocument();
    }
  }

  public void skippedEntity(java.lang.String name) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].skippedEntity( name);
    }
  }

  public void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].processingInstruction(target, data);
    }
  }

  public void ignorableWhitespace(char[] ch, int start, int length) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].ignorableWhitespace( ch,  start,  length);
    }
  }

  public void characters(char[] ch, int start, int length) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].characters( ch,  start,  length);
    }
  }

  public void startPrefixMapping(java.lang.String prefix, java.lang.String uri) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].startPrefixMapping( prefix,uri);
    }
  }

  public void endPrefixMapping(java.lang.String prefix) throws SAXException{
    for (int i=0; i<iNbContentHandler; i++) {
      iListOfContent[i].endPrefixMapping( prefix);
    }
  }

} //end class
