/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.ContentHandler;


/**
  * This class based on the TProcessBasic allow to define
  * a Connector. A connector is a N -> 1 element. 
  * It 's allow to merge a set of ContentHandler flow

  * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
  * @since jdk 1.2 / SAX 2.0
  @see fr.fluxmedia.transmorpher.TProcessFactory.OneMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.MultipleMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.ProcessBasic
 */
 
public final class TConnector 
  extends TProcessBasic {

  /** The multiple mixer which realize the merge */
  MultipleMixer iMM = null;

  /** The constructor */
  public TConnector (String[] pIn, String[] pOut) {
    super(pIn,pOut);
  
    // The first current mixer is the first one
    iMM = new MultipleMixer(iNbIn);
    iMM.getMixer(0).setCurrent(true);
    
    //creation of the In port
    for (int i=0;i<iNbIn; i++) {
      iListIn[i] = new XML_Port(pIn[i],this,iMM.getMixer(i),i,XML_Port.IN);
    }//end for

    //Creation of the out port 
    iListOut[0]= new XML_Port(pOut[0],this,this,0,XML_Port.OUT);   
    
  } //end constructor
  
  /** Allow to set the content handler on Mixer for out port*/
  public final void setContentHandler(ContentHandler pContentHandler ) {
    iMM.setContentHandler(pContentHandler);
  }
  
  /** Allow to get the content handler for in port */
  public final ContentHandler getContentHandler( ) {
    return iMM.getContentHandler();
  } 

  /** Copy the connector, this method is called by the copy method of the PRocess_impl classes */
  public final TProcess internalCopy() {
    String[] vPortNameOut = new String [getOut().length];
    XML_Port[] out = getOut();
    for (int i =0; i<vPortNameOut.length; i++) {
      vPortNameOut[i]=out[i].getCompositeName();
    }
    String[] vPortNameIn = new String [getIn().length];
    out = getIn();
    for (int i =0; i<vPortNameOut.length; i++) {
      vPortNameIn[i]=out[i].getCompositeName();
    }
        
    TConnector vAns = new TConnector(vPortNameIn,vPortNameOut);  
    return vAns ;
  }
  
}
