/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.ContentHandler;

// Imported TraX classes

import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;


// Imported SAX classes

import org.xml.sax.SAXException;


// Imported JAVA API for XML Parsing 1.0 classes

import java.io.IOException;

/**
  * This class based on the TProcessBasic allow to define
  * a Connector. A connector is a N -> 1 element. 
  * It 's allow to merge a set of ContentHandler flow

  * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
  * @since jdk 1.2 / SAX 2.0
  @see fr.fluxmedia.transmorpher.TProcessFactory.OneMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.MultipleMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.ProcessBasic
 */
 
public final class TLoopStack1
  implements OneMixerHandler {

  LoopStackMixer iMyMixer = null;
  TLoopUtility iFather ;
  public TLoopStack1(boolean pActive,TLoopUtility pFather )
  throws TransformerException, TransformerConfigurationException,
                              SAXException, IOException {
    iMyMixer = new LoopStackMixer(this);
    iMyMixer.setCurrent(pActive);
    iFather = pFather ;
  }

  public ContentHandler getContentHandler() {
   return iMyMixer ;
  }

  public ContentHandler getContentHandlerIn() {
   return iMyMixer ;
  }

  public void setContentHandler(ContentHandler pCH) {
   iMyMixer.setContentHandler(pCH);
  }
 
  public void setContentHandlerOut(ContentHandler pCH) {
   iMyMixer.setContentHandler(pCH);
  }

  
  /** when a OneMixer is finished, we execute the stack of the next mixer, and then , set 
      the next mixer active */
  public final void IsFinished() throws SAXException {
    System.out.println("{LOOP : Le mixer = est fini et oui !!!");
    iFather.IsFinished(this);   
  } //end IsFinished

  public final void IsFinishedDuringStop()
  throws SAXException  {
    System.out.println("{LOOP : Le mixer = est fini et oui during stop!!!");
    try {
      iFather.IsFinishedDuringStop(this);    
    } catch (TransformerException e) {
      System.out.println("[TLoopStack1] erreur " +e );
    } catch (IOException e) {
      System.out.println("[TLoopStack1] erreur " +e );
    }
    
    
    
  } //end IsFinished
  
  public final void computeStack() throws SAXException {
    iMyMixer.ComputeStack();      
  }
  
  public final ContentHandlerInfoStack getContentHandlerInfoStack() {
    return iMyMixer.getContentHandlerInfoStack();
  }
  
  
}
