/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.ContentHandler;

// Imported TraX classes

import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;


// Imported SAX classes

import org.xml.sax.SAXException;


// Imported JAVA API for XML Parsing 1.0 classes

import java.io.IOException;

/**
  * This class based on the TProcessBasic allow to define
  * a Connector. A connector is a N -> 1 element.
  * It 's allow to merge a set of ContentHandler flow

  * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
  * @since jdk 1.2 / SAX 2.0
  @see fr.fluxmedia.transmorpher.TProcessFactory.OneMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.MultipleMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.ProcessBasic
 */

public final class TLoopUtility
  extends TProcessBasic {

  TProcess myProcess = null;
  TLoopStack1[] myLoopStackIn = null;
  TLoopStack1[] myLoopStackOut = null;
  TProcessComposite iFather = null;
  XML_Port[] iList1 = null;
  XML_Port[] iList2 = null;
  XML_Port[] iList3 = null;

  String[] iIn = null;
  String[] iOut = null;
  TProcess iProcess = null;

  public TLoopUtility(TProcess pProcess,
                      TProcessComposite pFather,
                      String[] pIn,
                      String[] pOut)
  throws TransformerException, TransformerConfigurationException,
         SAXException, IOException {

    super(pIn,pOut);

    //copy the port name
    iIn = pIn ;
    iOut = pOut ;
    iFather  = pFather ;
    iProcess = pProcess;

    //The first One
    myProcess=pProcess.Copy(pFather);

    //One loop stack for all port
    myLoopStackIn = new TLoopStack1[pIn.length];
    myLoopStackOut = new TLoopStack1[pOut.length];
    iList1 = new XML_Port[pIn.length];
    iList2 = new XML_Port[pOut.length];
    iList3 = new XML_Port[pOut.length];
//    iListIn = new XML_Port[pIn.length];
//    iListOut = new XML_Port[pIn.length];

    for (int i=0;i< pIn.length;i++) {
      System.out.println("TloopUtility:constructor]  : Creation d'un stackin / stackout" );
      //Input
      myLoopStackIn[i]=new TLoopStack1(true,this);
      myLoopStackOut[i]=new TLoopStack1(false,this);
      iListIn[i]=new XML_Port(pIn[i],this, myLoopStackIn[i].getContentHandler() ,i ,XML_Port.IN);
      iList1[i]=new XML_Port(pIn[i]+"_internal1",this, myLoopStackIn[i],i ,XML_Port.OUT);
      iList2[i]=new XML_Port(pIn[i]+"_internal2",this, myLoopStackOut[i].getContentHandler() ,i ,XML_Port.IN);
      iList3[i]=new XML_Port(pOut[i]+"_internal3",this, myLoopStackOut[i] ,i ,XML_Port.OUT);
      //OutPut
      System.out.println("TloopUtility:constructor]  : " +  pIn[i] );
      pFather.InsertUnlinkedInPort(pIn[i],iListIn[i]);
      pFather.InsertCompositeInPort(pIn[i]);
      pFather.InsertUnlinkedOutPort(pIn[i]+"_internal1",iList1[i]);
      pFather.InsertUnlinkedInPort(pIn[i]+"_internal2",iList2[i]);
      pFather.InsertUnlinkedOutPort(pIn[i]+"_internal3",iList3[i]);
    }

    //Onlink
    for (int i=0;i< pIn.length;i++) {
      iListIn[i].setName(pIn[i]);
      //les ports du process
      pFather.InsertUnlinkedInPort(pIn[i]+"_internal1",myProcess.getIn()[i]);
      pFather.InsertUnlinkedOutPort(pIn[i]+"_internal2",myProcess.getOut()[i]);
    }


    //on lie avec la sortie, c exeptionnelle


    //System.out.println("[TLoopUtility]debut liens ");
    pFather.CreateLink();
    //System.out.println("[TLoopUtility]fin liens ");

    //System.out.println("[TLoopUtility]On va faire les liens du composite ");
    pFather.LinkCompositePort();
  	//System.out.println("[TLoopUtility]On les a fait");

  	System.out.println("[TLoopUtility] On vient de creer un TLoopUtility avec : ");
  	for (int i=0;i<pIn.length;i++) {
    	System.out.println("[TLoopUtility] iL1[0] = " + iIn[i]+"_internal1");
    	System.out.println("[TLoopUtility] iL2[0] = " + iIn[i]+"_internal2");
    	System.out.println("[TLoopUtility] iL3[0] = " + iOut[i]+"_internal3");
  	}
  	
  }


  /** Copy the connector, this method is called by the copy method of the PRocess_impl classes */
  public final TProcess internalCopy() {
    String[] vPortNameOut = new String [getOut().length];
    XML_Port[] out = getOut();
    for (int i =0; i<vPortNameOut.length; i++) {
      vPortNameOut[i]=out[i].getCompositeName();
    }
    String[] vPortNameIn = new String [getIn().length];
    out = getIn();
    for (int i =0; i<vPortNameOut.length; i++) {
      vPortNameIn[i]=out[i].getCompositeName();
    }
    //..... euh faire qqc :)
    //TConnector vAns = new TConnector(vPortNameIn,vPortNameOut);
    //return vAns ;
    return null;
  }

  public final void IsFinished(TLoopStack1 pChild) {
    //System.out.println("TloopUtility:isFinished]  :" + pChild);
  }

  public final void IsFinishedDuringStop(TLoopStack1 pChild)
  throws TransformerException,
         TransformerConfigurationException,
         SAXException,
         IOException{

    System.out.println("TloopUtility:isFinishedduringStop]  :" + pChild +"_"+myLoopStackOut[0]);

    //only the second one, all the input and output is finished
    boolean b = CheckEquality();

    if (!b && (pChild != myLoopStackIn[0])) { //TODO tester tous les loopStackIn
      //it's equals stop, link with the composite
      //and compute the stack
     String [] iList3Name = new String[iList3.length];

     System.out.println("[TLoopUtility]debut creer nouveau loopUtility ");
    
     for (int i=0; i< iList3.length; i++) {
       iList3Name[i] = iList3[i].getName();
       System.out.println("[TLoopUtility] : in ["+i+"]=" + iList3Name[i] );
       System.out.println("[TLoopUtility] : out["+i+"]=" + iOut[i] );
     }


    ////// NOT HERE

      //insert the iList3 in the unliked port
      for (int i=0;i< iIn.length;i++) {
        //iListIn[i].setName(iIn[i]);
        //les ports du process
        //iFather.InsertCompositeOutPort(iIn[i]);
        //iFather.removeUnlinkedOutPort(iIn[i]+"_internal3"+"_internal3");
        //pFather.InsertUnlinkedOutPort(pIn[i],iList3[i]);
      }
  
      iFather.InsertUnlinkedOutPort(iIn[0]+"_internal3"+"_internal3",iList3[0]);      
	    TLoopUtility p1 = new TLoopUtility(iProcess,iFather, iList3Name, iOut);
	  
      //TLoopUtility p1 = new TLoopUtility(iProcess,iFather, iList3Name, iOut);
		
      ////// NOT HERE
      
      
      //System.out.println("debut liens ");
      iFather.CreateLink();
      //System.out.println("fin liens ");

      //System.out.println("On va faire les liens du composite ");
      iFather.LinkCompositePort();
      ////// NOT HERE
        pChild.computeStack();
    } else {
      // create a new looputility, link with it
      //and compute the stack
     System.out.println("[TLoopUtility] end of loop ");
     
      for (int i=0;i< iIn.length;i++) {
        iFather.InsertUnlinkedOutPort(iOut[i],iList3[i]);
        iFather.InsertCompositeOutPort(iOut[i]);
        iFather.setOut(i,iList3[i]);
      }

      ((TLoop)iFather).createLoopLink();
      pChild.computeStack();
    }

  }


  /** This method must be call after the end of one step */
  public final boolean CheckEquality() {
    ContentHandlerInfoStack[]  ContentHandlerInfoStackIn = new    ContentHandlerInfoStack [iIn.length] ;
    ContentHandlerInfoStack[]  ContentHandlerInfoStackOut = new    ContentHandlerInfoStack [iOut.length] ;
    //get the stack on In and Out port
    for (int i=0; i < iIn.length; i++) {
      ContentHandlerInfoStackIn[i]  =  myLoopStackIn[i].getContentHandlerInfoStack() ;
      ContentHandlerInfoStackOut[i] = myLoopStackOut[i].getContentHandlerInfoStack() ;
    } //end for
    boolean vAns = CheckEquality(ContentHandlerInfoStackIn[0],ContentHandlerInfoStackOut[0]);

    //System.out.println("EQUALITY TEST during the loop process :" + vAns );

    return vAns ;

  }


  private final boolean CheckEquality(ContentHandlerInfoStack pStack1,
                                      ContentHandlerInfoStack pStack2) {
    ContentHandlerInfo vCHI1 = null;
    ContentHandlerInfo vCHI2 = null;

    if (pStack1.size() != pStack2.size() ) {
      System.out.println("EQUALITY TEST during the loop process : les deux n'ont pas la meme taille " );
      System.out.println("T1 = " + pStack1.size() );
      System.out.println("T2 = " + pStack2.size() );
        return false ;
    }
    //else
    int size = pStack1.size();
    for (int i=0; i<size; i++) {
      vCHI1 = pStack1.get(i);
      vCHI2 = pStack2.get(i);
      System.out.println("EQUALITY TEST during the loop process :" + i );
      if ( vCHI1.getCommand() != vCHI1.getCommand() ){
        return false ;
      } //Else Continue les commandes sont equivalantes
    }
    return true ;
  }




  //idee : mettre un OneMixer sur chaque sortie du loop
  //faire les tests sur les ports adaptes

  // Si ok :
    // on lache tout dans les sorties du loop

  //sinon
    // On creer un nouveau LoopElement et on met tout dedanset on link directement




}

