/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;


/**
  * one of the main classes of the transmorpher. This class
  * represent the main class of all TProcess. It's defines the 
  * XML_PORT mechanism
  *
  * @author Laurent.Tardif@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */
public interface TProcess {

    
  /** Get the name of the process */  
  public String getName();
  
  /** Set the name of the process*/
  public void setName(String pName) ;
  
  /* set an In port */
  public void setIn(int i,XML_Port pFileIn) ;
  
  /** Set an Out Port */
  public void setOut(int i,XML_Port pFileOut) ;
  
  /** Get an In port */
  public XML_Port getIn(int i) ;
  
  /** Get an Out Port */ 
  public XML_Port getOut(int i) ;
  
  /** Get the In ports */
  public XML_Port[] getIn() ;
  
  /** Get the Out Ports */ 
  public XML_Port[] getOut() ;
  
  /** Create a copy of this element in the composite given in parameter */
  public TProcess Copy(TProcessComposite vFather) ;
  
  /** internal copy, call by XSLProcess_impl */
  public TProcess internalCopy() ;
      
}
