/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;


/**
  * one of the main classes of the transmorpher. This class
  * represent the main class of all TProcess. It's defines the
  * XML_PORT mechanism
  *
  *
  * @since jdk 1.3 / SAX 2.0
  */
public abstract class TProcess_Impl
  implements TProcess{

  /** The In port */
  XML_Port [] iListIn = null;
  
  /** the current In port */
  int iNbIn = 0;
    
  /** The out PORT */
  XML_Port [] iListOut = null ;
  
  /** The List of out port */
  int iNbOut =0 ;
  
  /** The name of the process */
  String iName = null;
  
  /** The constructor */
  protected TProcess_Impl() {
    //System.out.println("{ TProcess] creation");
    //TODO : pour etre moins debile mettre un dispatcher a la sortie des basic
    //       des que cela est necessaire
    // Faire une methode add listener ? => PB des ports ?
  }
  
  
  /** The constructor */
//  public TProcess(int pNbIn, int pNbOut) {
  public TProcess_Impl(String[] pIn, String[] pOut) {
    this();
    iListIn=new XML_Port[pIn.length];
    iNbIn = pIn.length;
    iListOut=new XML_Port[pOut.length];
    iNbOut = pOut.length;
  } //end constructor
    
    
  /** Get the name of the process */
  public final String getName() {
    return iName;
  }
  
  /** Set the name of the process*/
  public final void setName(String pName) {
    iName=pName;
  }
  
  /* set an In port */
  public final void setIn(int i,XML_Port pFileIn) {
    iListIn[i]=pFileIn;
  }
  
  /** Set an Out Port */
  public final void setOut(int i,XML_Port pFileOut) {
    iListOut[i]=pFileOut;
  }
  
  /** Get an In port */
  public final XML_Port getIn(int i) {
    return iListIn[i];
  }
  
  /** Get an Out Port */
  public final XML_Port getOut(int i) {
    return iListOut[i];
  }
  
  /** Get the In ports */
  public final XML_Port[] getIn() {
    return iListIn;
  }
  
  /** Get the Out Ports */
  public final XML_Port[] getOut() {
    return iListOut;
  }
  
  
  /** Create a copy of this element in the composite given in parameter */
  public final TProcess Copy(TProcessComposite vFather) {
    //System.out.println("COPY : " +getName());

    // Copy the element
    TProcess vProcess = internalCopy();
    // Insert Unliked port in the father
    XML_Port[] In = vProcess.getIn();
    XML_Port[] Out = vProcess.getOut();
    
    vFather.addProcess(vProcess);
    for (int i=0; i<In.length; i++) {
      //System.out.println("[Process::Copy] + IN :"+ In[i].getName()+" : " +In[i]);
      //System.out.println("[Process::Copy] + IN :"+ In[i].getCompositeName()+" : " +In[i]);
      vFather.InsertUnlinkedInPort(In[i].getCompositeName(),In[i]);
    }
    for (int i=0; i<Out.length; i++) {
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getName()+" : " +Out[i]);
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getCompositeName()+" : " +Out[i]);
      if (Out[i]!=null) {
		vFather.InsertUnlinkedOutPort(Out[i].getCompositeName(),Out[i]);
	  } //else it's for loop, the out port are not know staticaly
    }
    return vProcess;
  }
  
  //todo private
  public abstract TProcess internalCopy() ;
      
}
