/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported TraX classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX Classes 

import org.xml.sax.AttributeList;
import org.xml.sax.HandlerBase;
import org.xml.sax.helpers.ParserFactory;
import org.xml.sax.Parser;
import org.xml.sax.SAXException ;

// Imported java.io classes

import java.io.IOException;

//Imported Transmorpher CLasses 

import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;


public final class TQuery 
  extends HandlerBase 
  implements TProcess {

  ///////// Copy of the  TProcess Imp

  /** The number of max IN PORT */
    //  static final int MAX_IN    = 10;

  /** The number of max OUT PORT */
    //  static final int MAX_OUT   = 10;

  /** The In port */
  XML_Port [] iListIn = null;
  
  /** the current In port */
  int iNbIn = 0;
    
  /** The out PORT */  
  XML_Port [] iListOut = null ;
  
  /** The List of out port */
  int iNbOut =0 ;
  
  /** The name of the process */
  String iName = null;
  
  /////// end of  PRocess Impl
  


  private static final String
        DEFAULT_PARSER_NAME = "com.ibm.xml.parsers.SAXParser";

  /** XML Parser */
  javax.xml.parsers.SAXParser iParser = null;
  
  
  TTransformer iTransformer = null ;
  
  ReadWrite FileRW = null;
  
  String iQueryFilename = null;
  String iRoot = null;
  /** The instance  constructor 
  
  @throws TransformerException
  @throws TransformerConfigurationException
  @throws SAXException
  @throws IOException
  
  */
  public TQuery (String[] pIn, String[] pOut,String pQueryFilename) 
    throws TransformerException, TransformerConfigurationException, 
           SAXException, IOException	 {
    
    //// copy of the TProcess Impl
    iListIn=new XML_Port[pIn.length];
    iNbIn = pIn.length;
    iListOut=new XML_Port[pOut.length];
    iNbOut = pOut.length;
    ///// end of the copy of the TProcess Impl
    iQueryFilename = pQueryFilename ;
    
    //Create the parser 
    FileRW = new ReadWrite(iQueryFilename+".xsl",Constants.WRITE); 
    try {
      //iParser = ParserFactory.makeParser(DEFAULT_PARSER_NAME);
      iParser = javax.xml.parsers.SAXParserFactory.newInstance().newSAXParser() ;
      iParser.parse(iQueryFilename,this);
    } catch (javax.xml.parsers.ParserConfigurationException CNFE) {
      System.out.println("TQuery :Error [" + CNFE +"]");
    } catch (SAXException SE) {
      System.out.println("[TQuery]Error SAX(" + SE+")");
      System.out.println("[TQuery]Error SAX(" + SE.getMessage()+")");
      System.out.println("[TQuery]Error SAX(" + SE.getException()+")");
  	  SE.printStackTrace();
    } catch (java.io.IOException IOE) {
      System.out.println("[TQuery]Erreur IO(" + IOE+")");
    }
  
     FileRW.Writeln("</xsl:stylesheet>") ;
     FileRW.Close();
    //super(pIn,pOut);
    //iTransformer = new TTransformer(pIn,pOut,iQueryFilename+".xsl");
    iTransformer=(TTransformer)TProcessFactory.newTransformer("xslt",pIn,pOut,iQueryFilename+".xsl");
    iListIn = iTransformer.getIn();
    iListOut = iTransformer.getOut();
  } //End constructor  
  
  
  /** Call by the XML parser at the begining of an element */
  public final void startElement(String pName, AttributeList attrs) {
    String vName = pName.toLowerCase();
    if (vName.equals("query")) {
      //System.out.println("startElement TQuery : " + vName);
      iRoot=attrs.getValue("root");
      WriteHeader();      
    } else if (vName.equals("select")) {
      //System.out.println("startElement TQuery : " + vName);
      WriteSelect(attrs.getValue("expr"));
    } else {
      System.out.println("startElement TQuery : Element inconnu : " + vName);
    }
  } //end proc startElement 
  
  private final void WriteHeader() {
    FileRW.Writeln("<?xml version=\"1.0\"?>"); 
    FileRW.Writeln("<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\">");
    FileRW.Writeln("");    
    FileRW.Writeln("<!-- ************************************************************ -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- This style sheet was generated by the FluxMdia Transmorpher -->");    
    FileRW.Writeln("<!--                                                              -->");    
    FileRW.Writeln("<!-- ************************************************************ -->");    
    FileRW.Writeln("");    
    FileRW.Writeln("  <xsl:template match=\"/\">");
    FileRW.Writeln("<"+iRoot+">");        
    FileRW.Writeln("    <xsl:apply-templates select=\"*\"/>");
    FileRW.Writeln("</"+iRoot+">");            
    FileRW.Writeln("  </xsl:template>");    
    
//    FileRW.Writeln("  <xsl:template match=\"@*\">");
//    FileRW.Writeln("      <xsl:attribute name=\"{name()}\"> <xsl:value-of select=\".\"/>");
//    FileRW.Writeln("      </xsl:attribute>");
//    FileRW.Writeln("  </xsl:template>");
//    FileRW.Writeln("");         
    FileRW.Writeln("  <xsl:template match=\"text()\"/>");
    FileRW.Writeln("");     
  }        


  private final void WriteSelect(String pSelect) {  
    FileRW.Writeln(" <!-- copy les element ou et leur attributs -->");
    FileRW.Writeln("   <xsl:template match=\""+pSelect+"\">");
    FileRW.Writeln("    <xsl:copy-of select=\".\"/>");
    FileRW.Writeln("  </xsl:template>");
    FileRW.Writeln("");         
  }
    
  
  //////Copy of the TProcess Impl
  
     
  /** Get the name of the process */  
  public final String getName() {
    return iName;
  }
  
  /** Set the name of the process*/
  public final void setName(String pName) {
    iName=pName;
  }
  
  /* set an In port */
  public final void setIn(int i,XML_Port pFileIn) {
    iListIn[i]=pFileIn;  
  }
  
  /** Set an Out Port */
  public final void setOut(int i,XML_Port pFileOut) {
    iListOut[i]=pFileOut;  
  }
  
  /** Get an In port */
  public final XML_Port getIn(int i) {
    return iListIn[i];
  }
  
  /** Get an Out Port */ 
  public final XML_Port getOut(int i) {
    return iListOut[i];
  }
  
  /** Get the In ports */
  public final XML_Port[] getIn() {
    return iListIn;
  }
  
  /** Get the Out Ports */ 
  public final XML_Port[] getOut() {
    return iListOut;
  }
  
  
  /** Create a copy of this element in the composite given in parameter */
  public final TProcess Copy(TProcessComposite vFather) {
    //System.out.println("COPY : " +getName());

    // Copy the element 
    TProcess vProcess = internalCopy();
    // Insert Unliked port in the father
    XML_Port[] In = vProcess.getIn();
    XML_Port[] Out = vProcess.getOut();
    
    vFather.addProcess(vProcess);
    for (int i=0; i<In.length; i++) {
      //System.out.println("[Process::Copy] + IN :"+ In[i].getName()+" : " +In[i]);
      //System.out.println("[Process::Copy] + IN :"+ In[i].getCompositeName()+" : " +In[i]);      
      vFather.InsertUnlinkedInPort(In[i].getCompositeName(),In[i]);
    }
    for (int i=0; i<Out.length; i++) {
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getName()+" : " +Out[i]);
      //System.out.println("[Process::Copy] + OUT :"+ Out[i].getCompositeName()+" : " +Out[i]);      
      vFather.InsertUnlinkedOutPort(Out[i].getCompositeName(),Out[i]);
    }
    return vProcess;
  }
  
  /** Copy the Query. only copy the transformer box, and use the same xsl file */
  public final TProcess internalCopy() {
    TQuery vAns =null;
    
    String[] vPortName = new String [getOut().length];
    XML_Port[] out = getOut();
    for (int i =0; i<vPortName.length; i++) {
      vPortName[i]=out[i].getCompositeName();
    }

    String[] vPortNameIn = new String [getIn().length];
    XML_Port[] in= getIn();
    for (int i =0; i<vPortNameIn.length; i++) {
      vPortNameIn[i]=in[i].getCompositeName();
    } 
  
   try {
    vAns = new TQuery(vPortNameIn,vPortName, iQueryFilename);
   } catch (Exception e) {
      System.out.println("Erreur lors de la copy d'un TQuery");
   }
   return vAns;
  } 
  
  /////// end of   Copy of the TProcess Impl
     
}//end class

