/**
   TProcess
*/

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;

// Imported Serializer classes

import org.apache.xalan.serialize.Serializer;
import org.apache.xalan.serialize.SerializerFactory;
import org.apache.xalan.templates.OutputProperties;

// Imported java.io classes
import java.io.FileOutputStream;
import java.io.File;
import java.io.IOException;

/**
  * This class offer a serializer mechanisme. A way to finish the transphormation process
  * bye writing XML output file
  *
  * @author laurent tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  */

public final class TSerializer 
  extends TProcessBasic{

  /** the serializer */
  Serializer serializer = null;
  
  String iXML_Filename = null;
    
  java.util.Properties Op = OutputProperties.getDefaultMethodProperties("xml");

  /** The constructor */
  public TSerializer (String[] pIn,String pFilename)  
    throws SAXException, IOException	 {
    super(pIn,new String[0]);
    //System.out.println("{ TProcess] creation d un serializer");
    iXML_Filename = pFilename ;

    if (pFilename.endsWith("html")) {
      Op = OutputProperties.getDefaultMethodProperties("xml");
    } else if (pFilename.endsWith("xml")) {
      Op = OutputProperties.getDefaultMethodProperties("xml");
    } else if (pFilename.endsWith("bib")) {
      Op = OutputProperties.getDefaultMethodProperties("text");
    }


    
    Op.setProperty("encoding","iso-8859-1");
    
    serializer = SerializerFactory.getSerializer(Op);   
     
    FileOutputStream FOS =  new FileOutputStream(new File(pFilename));
    serializer.setOutputStream(FOS);
    iListIn[0]=new XML_Port(pIn[0],this,(ContentHandler)serializer.asContentHandler(),0,XML_Port.IN);
  } //end constructor 
  
  
  /** Copy this component */
  public final TProcess internalCopy() {
    try {
      String[] vPortNameIn = new String [getIn().length];
      XML_Port[] in= getIn();
      for (int i =0; i<vPortNameIn.length; i++) {
        vPortNameIn[i]=in[i].getCompositeName();
      } 
      TProcess vAns = new TSerializer(vPortNameIn,iXML_Filename);
      return vAns ;
    } catch (Exception E) {
      // SAXException, IOException
      System.out.println("Erreur lors de la copie d'un TSerializer");
    }
    return null;
  }
   

} //end class
